package betterwithmods.client.model;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockKiln;
import betterwithmods.common.blocks.tile.TileCamo;
import com.google.common.collect.ImmutableList;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.block.model.*;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.Biome;
import net.minecraftforge.client.MinecraftForgeClient;
import net.minecraftforge.common.property.IExtendedBlockState;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * Created by primetoxinz on 6/4/17.
 */

public class BakedModelKiln implements IBakedModel {
    @Override
    public List<BakedQuad> func_188616_a(@Nullable IBlockState state, @Nullable EnumFacing side, long rand) {
        if(state.func_177230_c() != BWMBlocks.KILN)
            return Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178126_b().func_174951_a().func_188616_a(state, side, rand);

        BlockRenderLayer layer = MinecraftForgeClient.getRenderLayer();
        IBlockState heldState = ((IExtendedBlockState) state).getValue(BlockKiln.HELD_STATE);
        IBlockAccess heldWorld = ((IExtendedBlockState) state).getValue(BlockKiln.HELD_WORLD);
        BlockPos heldPos = ((IExtendedBlockState) state).getValue(BlockKiln.HELD_POS);

        if (heldWorld == null || heldPos == null) {
            return ImmutableList.of();
        }

        Minecraft mc = Minecraft.func_71410_x();
        if(heldState == null && layer == BlockRenderLayer.SOLID) {
            // No camo
            ModelResourceLocation path = new ModelResourceLocation("minecraft:brick_block");
            return mc.func_175602_ab().func_175023_a().func_178126_b().func_174953_a(path).func_188616_a(state, side, rand);
        } else if(heldState != null) {
            if(heldState.func_177230_c().canRenderInLayer(heldState, layer)) {
                IBlockState actual = heldState.func_177230_c().func_176221_a(heldState, new FakeBlockAccess(heldWorld), heldPos);

                // Steal camo's model
                IBakedModel model = mc.func_175602_ab().func_175023_a().func_178125_b(actual);

                // Their model can be smart too
                IBlockState extended = heldState.func_177230_c().getExtendedState(actual, new FakeBlockAccess(heldWorld), heldPos);
                return model.func_188616_a(extended, side, rand);
            }
        }

        return ImmutableList.of(); // Nothing renders
    }

    @Override
    public boolean func_177555_b() {
        return true;
    }

    @Override
    public boolean func_177556_c() {
        return false;
    }

    @Override
    public boolean func_188618_c() {
        return false;
    }

    @Override
    public TextureAtlasSprite func_177554_e() {
        return Minecraft.func_71410_x().func_147117_R().func_110572_b("betterwithmods:blocks/kiln");
    }

    @Override
    public ItemCameraTransforms func_177552_f() {
        return ItemCameraTransforms.field_178357_a;
    }

    @Override
    public ItemOverrideList func_188617_f() {
        return ItemOverrideList.field_188022_a;
    }

    private static class FakeBlockAccess implements IBlockAccess {

        private final IBlockAccess compose;

        private FakeBlockAccess(IBlockAccess compose) {
            this.compose = compose;
        }

        @Override
        public TileEntity func_175625_s(@Nonnull BlockPos pos) {
            return compose.func_175625_s(pos);
        }

        @Override
        public int func_175626_b(@Nonnull BlockPos pos, int lightValue) {
            return 15 << 20 | 15 << 4;
        }

        @Nonnull
        @Override
        public IBlockState func_180495_p(@Nonnull BlockPos pos) {
            IBlockState state = compose.func_180495_p(pos);
            if(state.func_177230_c() instanceof BlockKiln) {
                state = ((TileCamo) compose.func_175625_s(pos)).camoState;
            }
            return state == null ? Blocks.field_150350_a.func_176223_P() : state;
        }

        @Override
        public boolean func_175623_d(@Nonnull BlockPos pos) {
            return compose.func_175623_d(pos);
        }

        @Nonnull
        @Override
        public Biome func_180494_b(@Nonnull BlockPos pos) {
            return compose.func_180494_b(pos);
        }

        @Override
        public int func_175627_a(@Nonnull BlockPos pos, @Nonnull EnumFacing direction) {
            return compose.func_175627_a(pos, direction);
        }

        @Nonnull
        @Override
        public WorldType func_175624_G() {
            return compose.func_175624_G();
        }

        @Override
        public boolean isSideSolid(@Nonnull BlockPos pos, @Nonnull EnumFacing side, boolean _default) {
            return compose.isSideSolid(pos, side, _default);
        }
    }
}
